//+------------------------------------------------------------------+
//|                
//|         
//          3-  
//
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
//+------------------------------------------------------------------+
class Correlation
   {
      private:
            int clProba ;
//------------------------------------------------------------------------------      
      public:
            void Corrlation() ;//  
            double Spirman(const double& mass1[],const double&  mass2[]) ;//    
            double Yukio(const double& mass1[],const double& mass2[]) ;//  
            double Pirson(const double& mass1[],const double&  mass2[]) ;//   
            bool   isNewBar();  //  true    
//-----------------------------------------------------------------------------
      protected:            
   };
//==============================================================================
double   Correlation::Spirman(const double& mass1[],const double&  mass2[])
   {
      if (ArraySize(mass1) != ArraySize(mass2)) return(2) ;//   
      int N=ArraySize(mass1),i,j ;
      double d=0,r=0 ,rx[],ry[],RxRang[],RyRang[],Summ=0 ;
      ArrayResize(rx,N,0); ArrayResize(ry,N,0) ;ArrayResize(RxRang,N,0) ;ArrayResize(RyRang,N,0) ;
      ArrayCopy(rx,mass1,0,0,N) ; ArrayCopy(ry,mass2,0,0,N) ;
      ArraySort(rx) ;ArraySort(ry) ;
      for (i=0 ;i<N; i++)
         {
            for (j=0 ;j<N ;j++)
               {
                  if ( rx[i] == mass1[j])
                     RxRang[i]=j ;
                  if ( ry[i] == mass2[j])
                     RyRang[i]=j ;
               }
         }
       for ( i=0 ; i< N ;i++)
         {
            Summ+=pow(RxRang[i]-RyRang[i],2) ;
         }
       r=1-(6*Summ/(N*(pow(N,2)-1))) ;
       return(r) ;
   }
//=============================================================================
double   Correlation::Yukio(const double& mass1[],const double& mass2[])
   {
      if (ArraySize(mass1) != ArraySize(mass2)) return(2) ;//    
      int N=ArraySize(mass1) ,i;
      double f[],g[],SrednF=0,SrednG=0 ,SummFG=0 ,SummF=0,SummG=0,r=0;
      ArrayResize(f,N,0) ;ArrayResize(g,N,0) ;
      for (i=0 ;i<N ;i++)
         {
            SrednF+=mass1[i] ;
            SrednG+=mass2[i] ;
         }
         SrednF=SrednF/N ;  SrednG=SrednG/N ;
      for (i=0 ; i<N ;i++)
         {
            f[i]=mass1[i]-SrednF ;
            g[i]=mass2[i]-SrednG ;
         }
      for (i=0 ;i<N ;i++)
         {
            SummFG+=f[i]*g[i] ;
            SummF+=pow(f[i],2) ;
            SummG+=pow(g[i],2) ;
         }
     r=SummFG/(sqrt(SummF)*sqrt(SummG)) ;
      return(r) ;
   }
//============================================================================
double   Correlation::Pirson(const double &mass1[],const double &mass2[])
   {
      if (ArraySize(mass1) != ArraySize(mass2)) return(2) ;//   
      int N=ArraySize(mass1),i ;
      double SrednMass1=0 ,SrednMass2=0 ,Summ=0,Summ2mass1=0 ,Summ2mass2=0,r=0;
      for (i=0; i<N;i++)
         {
            SrednMass1+=mass1[i] ;
            SrednMass2+=mass2[i] ;
         }
      SrednMass1=SrednMass1/N ;
      SrednMass2=SrednMass2/N ;
      for (i=0 ; i< N ;i++)
         {
            Summ+=(mass1[i]-SrednMass1)*(mass2[i]-SrednMass2) ; 
            Summ2mass1+=pow(mass1[i]-SrednMass1,2) ;
            Summ2mass2+=pow(mass2[i]-SrednMass2,2) ;          
         }
      r=Summ/sqrt(Summ2mass1*Summ2mass2) ;
      return(r) ;
   }
//========================================================================================
//  true     
bool Correlation::isNewBar()
  {
   static long last_time=0;
   long lastbar_time=SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE);
   if(last_time==0)
     {
      last_time=lastbar_time;
      return(false);
     }
   if(last_time!=lastbar_time)
     {
      last_time=lastbar_time;
      return(true);
     }
   return(false);
  };
void Correlation::Corrlation(void)
{
   clProba=0 ;
}